unit UnitDFT;

interface

uses Classes;


type


 TDFT = class
  private
  public
    nmax:integer;
    kmax:integer;
    nkT:real;// 
    ADC:integer;
    T:real;
    Avg:real;
    sin_nmax:TMemoryStream;
    cos_nmax:TMemoryStream;
    fint:TMemoryStream;
    constructor Create;
    Function ReDFTQ (kg:integer):real;
    Function ImDFTQ (kg:integer):real;
//    Procedure Create_SinCos;
//    procedure SetParam;
  end;



implementation

{*************************************************}
constructor TDFT.Create;
begin

   sin_nmax := TMemoryStream.Create;
   cos_nmax := TMemoryStream.Create;
   fint     := TMemoryStream.Create;

   sin_nmax.Seek(0, soFromBeginning);
   cos_nmax.Seek(0, soFromBeginning);
   fint.Seek(0, soFromBeginning);

end;
{*************************************************}
{
procedure TDFT.setparam;
begin
   T := 2*pi/nmax;
   Create_SinCos;
end;
}
{*************************************************}
Function TDFT.ReDFTQ (kg:integer):real;
var
 sum,mul:longint;
 pr:integer;
 n:word;
 adcadc:real;
 S:integer;
begin
 sum:=0;
 S:= sizeof(pr);
 adcadc:=ADC*ADC;
 sin_nmax.Seek(kg*nmax*S, soFromBeginning);
 cos_nmax.Seek(kg*nmax*S, soFromBeginning);
 fint.Seek(0, soFromBeginning);

 for n:=0 to nmax-1 do
   begin
  //  mul:=F_int[n];

    Fint.ReadBuffer(mul,S);
    cos_nmax.ReadBuffer(pr,S);
 //   pr:=round(cos(n*kg*T)*ADC);
    sum:=sum+mul*pr;
   end;
 ReDFTQ:=sum/adcadc;
end;
{*************************************************}
Function TDFT.ImDFTQ (kg:integer):real;

var
 sum,mul:longint;
 pr:integer;
 n:word;
 adcadc:real;
 S:integer;

begin
 sum:=0;
 S:= sizeof(pr);
 adcadc:=ADC*ADC;
 sin_nmax.Seek(kg*nmax*S, soFromBeginning);
 cos_nmax.Seek(kg*nmax*S, soFromBeginning);
 fint.Seek(0, soFromBeginning);

 for n:=0 to nmax-1 do
  begin
//   mul:=F_int[n];
    Fint.ReadBuffer(mul,S);
    sin_nmax.ReadBuffer(pr,S);
    //   sum:=sum +mul*K_sin[n,kg];
//    pr:=round(sin(n*kg*T)*ADC);
    sum:=sum+mul*pr;
  end;
// ImDFTQ:=sum/DFT_ADC/DFT_ADC;
 ImDFTQ:=sum/adcadc;
end;
{*************************************************}
{
procedure TDFT.Create_SinCos;
var k,n:integer;
pr:integer;
S:integer;

begin

// for k:=0 to DFT_kmax-1 do
//  for n:=0 to DFT_nmax-1 do
//   begin
//     K_sin[n,k]:=round(sin(n*k*DFT_T)*DFT_ADC);
//     K_cos[n,k]:=round(cos(n*k*DFT_T)*DFT_ADC);
//   end;

 sin_nmax.Seek(0, soFromBeginning);
 cos_nmax.Seek(0, soFromBeginning);

 S:=Sizeof(pr);
 for k:=0 to kmax-1 do
  for n:=0 to nmax-1 do
   begin
    nkT:=n*k*T;
    pr:=round(sin(nkT)*ADC);
    sin_nmax.WriteBuffer(pr,S);
    pr:=round(cos(nkT)*ADC);
    cos_nmax.WriteBuffer(pr,S);
   end;



end;
}





end.
